你的位置:首页 > ASP.net教程

[ASP.net教程]在传统.NET Framework 上运行ASP.NET Core项目


新的项目我们想用ASP.NET Core来开发,但是苦于我们历史的遗产很多,比如《使用 JavaScriptService 在.NET Core 里实现DES加密算法》,我们要估计等到.NET Core 1.2我们才会有大部分的API,通过NodeJs方式有点曲线救国的味道,很多人会不认同,如果要在纯的.NET Core下运行我们的ASP.NET Core项目,在特定的时间进度内很难办到,不仅仅我们所依赖的一些API还没有,还有我们大量的.NET Framwork的库还来不及迁移到.NET Standard 兼容。本文就是向你介绍如何在我们的.NET Framework 4.5以上的环境下跑我们的ASP.NET Core项目,让我们跟上.NET Core的发展步伐。

 

Scott hanselman 写了一篇文章《How to reference an existing .NET Framework Project in an ASP.NET Core 1.0 Web App》向我们介绍了如何.NET Framework 4.5以上的环境下跑我们的ASP.NET Core项目。这篇文章里有一张图解释了这么做的原理:

 aspnetcore46

.NET 4.5以上的版本和.NET Core的底层的编译器和运行时都是一样的,ASP.NET Core 1.0也可以跑在NET Framework 4.6上,我们通过Visual Studio 2015 Update 3创建一个Web项目的时候有一个模板:

image

我们上面看到了3个ASP.NET Web项目类型:

  • ASP.NET Web 应用程序。这就是 4.6版本的 ASP.NET MVC 与 Web API。它在.NET 框架上运行。
  • ASP.NET Core Web应用程序在.NET Core 1.0 上运行,它是跨平台的。如果你选择它创建项目,你将能够在任何地方运行您的应用程序,但您不能引用"完整的".NET Framework 程序集
  • ASP.NET Core Web应用程序在.NET 框架上运行。那就是新的 ASP.NET Core 1.0 ,统一了 MVC 和 Web API,不支持WebForms,但在Windows的.NET 框架上运行。这里有同学就有疑问了,最新的Mono 4.6 也实现了.NET 4.5的API,这个项目模板的应用能否在Mono上跑呢,答案应该是不行,因为Mono的底层编译器和运行时还没有和.NET Core统一,不过Mono正在路上,已经开始统一底层的编译器和运行时,具体大家可用去https://trello.com/b/vRPTMfdz/net-framework-integration-into-mono ,了解具体的工作进展,下个稳定版本Mono 4.8应该就可以支持了,具体可以参考 Dockerized .NET Core 1.0.1 and .NET Framework on Mono 4.7。

我们选择ASP.NET Core Web应用程序在.NET 框架上运行模板创建项目,创建出来是这样的:

image 

 

接着我们再创建2个.NET Framework 4.5的库,然后在asp.net core应用里面引用:

image

image

我们来看asp.net core项目的project.json, 不久的将来在Visual Studio 2017 RC发布的时候,project.json 的功能会和csproj以及msbuild 合并在一起, 你会注意到 ClassLIbrary1 没有列出的最高级别依赖项节点下,但作为一种框架特定依赖像这样:

image

此外请注意,在这种情况下它是一种type="project"的依赖关系,在这种情况下,我没有建立 NuGet 包来进行引用。不过因为 .NET Core toolin 是在预览中有一些缺陷,这些缺陷要等等工具完善来修复。